package com.yizhi.enroll.application.vo.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.yizhi.enroll.application.vo.MessageRemindVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 报名主体表，入口在培训项目
 * </p>
 *
 * @author bob123
 * @since 2018-03-07
 */
@Data
@ApiModel(value = "Enroll", description = "报名主体表")

public class Enroll {

	private static final long serialVersionUID = 1L;
	
	@ApiModelProperty(notes = "主键id")
	
	private Long id;
    
	@ApiModelProperty(notes = "培训项目_id")
    
    private Long trainingProjectId;
    
	@ApiModelProperty(notes = "报名开始时间")
    
    private Date startTime;
    
	@ApiModelProperty(notes = "报名结束时间")
    
    private Date endTime;
    
	@ApiModelProperty(notes = "报名人数限制（0：不限制）默认0")
    
    private Integer personLimitNum;
    
	@ApiModelProperty(notes = "是否需要审核（0：不需要；1：需要）。默认0")
    
    private Integer needAudit;
    
	@ApiModelProperty(notes = "报名须知")
    private String notice;
    
	@ApiModelProperty(notes = "创建者id", hidden = true)
    
    private Long createById;
    
	@ApiModelProperty(notes = "创建者名称", hidden = true)
    
    private String createByName;
    
	@ApiModelProperty(notes = "创建时间", hidden = true)
    
    private Date createTime;
    
	@ApiModelProperty(notes = "更新者id", hidden = true)
    
    private Long updateById;
    
	@ApiModelProperty(notes = "修改者名称", hidden = true)
    
    private String updateByName;
    
	@ApiModelProperty(notes = "修改时间", hidden = true)
    
    private Date updateTime;
    
	@ApiModelProperty(notes = "企业_ID", hidden = true)
    
    private Long companyId;
	
	@ApiModelProperty(notes = "部门_ID", hidden = true)
    
    private Long orgId;
	
	@ApiModelProperty(notes = "站点_ID", hidden = true)
    
    private Long siteId;

    @ApiModelProperty(value = "各个业务设置提醒时的数据")
    
    private MessageRemindVo messageRemindVo;

	@ApiModelProperty(value = "是否付费报名，默认0")
	private Integer enablePay;

	@ApiModelProperty(value = "购买实际价格")
	private Integer actualPrice;

	@ApiModelProperty(value = "购买原价格")
	private Integer originalPrice;

}
