package com.yizhi.application.controller.manage;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;

import com.yizhi.application.domain.EnrollRecord;
import com.yizhi.application.service.EnrollRecordService;
import com.yizhi.util.application.constant.ReturnCode;
import com.yizhi.util.application.domain.Response;
import org.apache.commons.beanutils.ConvertUtils;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.*;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.enroll.application.vo.AuditVO;
import com.yizhi.enroll.application.vo.EnrollerParam;
import com.yizhi.enroll.application.vo.EnrollerVo;

import io.swagger.annotations.ApiParam;

/**
 * <p>
 * 记录学员报名信息 前端控制器 管理端
 * </p>
 *
 * @author bob123
 * @since 2018-03-07
 */
@RestController
@RequestMapping("/remote")
public class EnrollRecordManageController {

    private static final Logger LOG = LoggerFactory.getLogger(EnrollRecordManageController.class);

    @Resource
    private EnrollRecordService enrollRecordService;

    @PostMapping("/manage/enroll/auditEnroll")
    public boolean auditEnroll(@RequestBody AuditVO vo) {
        return enrollRecordService.auditEnroll(vo);
    }

    @PostMapping("/manage/enroll/exportRegistered")
    public Response<String> exportRegistered(@ApiParam(value = "用户关键字") String userKeyWord,
                                             @ApiParam(value = "所在部门") String orgIds, @ApiParam(value = "审核状态") Integer auditStatus,
                                             @ApiParam(value = "项目ID") Long trainingProjectId, HttpServletResponse response) {
        try {
            // 根据用户关键字 获取 所有用户信息 (模糊匹配)
            List<Long> userIdList = new ArrayList<Long>();
            List<Long> orgIdsList = new ArrayList<Long>();
            if (!StringUtils.isBlank(orgIds)) {
                Long[] strArrNum = (Long[]) ConvertUtils.convert(orgIds.split(","), long.class);
                orgIdsList = Arrays.asList(strArrNum);
            }
            Map<String, Object> map = new HashMap<String, Object>();
            map.put("userIdList", userIdList);
            map.put("orgIdsList", orgIdsList);
            map.put("auditStatus", auditStatus);
            map.put("trainingProjectId", trainingProjectId);

            // List<EnrollerVo> exportRegisteredList =
            // trEnrollRecordService.exportRegisteredList(map);
            // 账户集合

            // List<String> accountIdList =
            // null;//exportRegisteredList.stream().map(EnrollerVo::getAccountId).collect(Collectors.toList());
            // ID集合 获取用户信息 (用户名, 用户状态)
            // List<User> userList = null;

            // HSSFWorkbook workBook = new
            // ExportUtil().export(exportRegisteredList);
            // workBook.write(response.getOutputStream());

            return Response.ok();
        } catch (Exception e) {
            LOG.error("导出已报名用户:" + e);
            return Response.fail(ReturnCode.SERVICE_UNAVAILABLE);
        }
    }

    @GetMapping("/manage/enroll/listEnroll")
    public Page<EnrollerVo> listEnroll(@RequestBody EnrollerParam enrollerParam) {
        if (null == enrollerParam) {
            return null;
        }
        LOG.error("***************************************{}", enrollerParam.getUserIdList());
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("userIdList", enrollerParam.getUserIdList());
        map.put("orgIdList", enrollerParam.getOrgIds());
        map.put("trainningProjectId", enrollerParam.getTrainningProjectId());
        map.put("enableEnroll", enrollerParam.getEnableEnroll());
        map.put("state", enrollerParam.getState());
        map.put("pageNo", enrollerParam.getPageNo());
        map.put("pageSize", enrollerParam.getPageSize());

        Page<EnrollerVo> page = new Page<EnrollerVo>
                (Integer.valueOf(map.get("pageNo").toString()), Integer.valueOf(map.get("pageSize").toString()));

        return enrollRecordService.listEnroll(map, page);
    }

    @PostMapping("/manage/enroll/state/update")
    public Integer updateState(@RequestBody EnrollRecord enrollRecord) {
        return enrollRecordService.updateState(enrollRecord);
    }
}
